#include "hft.h"
#include "callbacks.h"

/* --- File menu ----------------------------------------------------- */ 

void on_tx_file_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	file_send();
}

void on_beacon_file_activate(GtkMenuItem *menuitem, gpointer user_data)
{
display_status("not yet implemented!");
/*
	if (beacon_on == 0) {
		beacon_on = 1;
		beacon_send();
	}
	if (beacon_on == 1) {
		beacon_on = 0;
	}
*/	
}


/* --- Spektrum ----------------------------------------------------- */ 
void on_frequency_spectrum_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	struct hfapp_msg msg;
	msg.hdr.type = htonl(HFAPP_MSG_REQ_SAMPLES);
	msg.hdr.len = htonl(sizeof(msg.data.u));
	msg.hdr.err = htonl(ERR_NOERR);
	msg.data.u = htonl(SPECTRUM_NUMSAMPLES);
	msg_send(&msg);
	scope_on = 1;
	gtk_widget_show(wspec);
	return;
	
}

gboolean on_spec_motion_event(GtkWidget *widget, GdkEventMotion *event, gpointer user_data)
{
	unsigned int freq;
	char buf[16];
	GtkEntry *entry;
	Spectrum *spec;

	freq = ((SRATE/2) * event->x + SPECTRUM_WIDTH/2) / SPECTRUM_WIDTH;
	snprintf(buf, sizeof(buf), "%d Hz", freq);
	entry = GTK_ENTRY(gtk_object_get_data(GTK_OBJECT(wspec), "specfreqpointer"));
	gtk_entry_set_text(entry, buf);
	spec = SPECTRUM(gtk_object_get_data(GTK_OBJECT(wspec), "spec"));
	spectrum_setmarker(spec, -1, -1, freq);
//	printf("on_scope_motion_event: x %g y %g\n", event->x, event->y);
	return FALSE;
}


gboolean on_spec_button_press_event(GtkWidget *widget, GdkEventButton *event, gpointer user_data)
{
	unsigned int freq, shift;

	freq = ((SRATE/2) * event->x + SPECTRUM_WIDTH/2) / SPECTRUM_WIDTH;
	shift = get_freq_shift();
	switch (event->button) {
	case 1:
		set_fsk_freq(freq, freq+shift);
		break;

	case 2:
		set_fsk_freq(freq-shift/2, freq+shift/2);
		break;

	case 3:
		set_fsk_freq(freq-shift, freq);
		break;
	}
//	printf("on_scope_button_press_event: x %g y %g  button 0x%04x\n", event->x, event->y, event->button);
	return FALSE;
}

gboolean on_wspec_delete_event(GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
	gtk_widget_hide(widget);
	scope_on = 0;
	return TRUE;
}


void on_parameters_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	gtk_widget_show(wpar);
}	



void on_parok_clicked(GtkButton *button, gpointer user_data)
{
	param_get();
	param_set();
	param_kernel();
	gtk_widget_hide(wpar);
	param_store();
}


void on_parcancel_clicked(GtkButton *button, gpointer user_data)
{
	param_set();
	gtk_widget_hide(wpar);
}


void on_quit_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	gtk_main_quit();
}


void on_become_irs_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	struct hfapp_msg msg;

	msg.hdr.err = htonl(ERR_NOERR);
	msg.hdr.len = htonl(0);
	msg.hdr.type = htonl(HFAPP_MSG_MODE_IRS);
	msg_send(&msg);
	display_status("SLAVE");
}


void on_become_iss_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	struct hfapp_msg msg;

	msg.hdr.err = htonl(ERR_NOERR);
	msg.hdr.len = htonl(0);
	msg.hdr.type = htonl(HFAPP_MSG_MODE_ISS);
	msg_send(&msg);
	display_status("MASTER");
}


void on_qrt_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	struct hfapp_msg msg;

	msg.hdr.err = htonl(ERR_NOERR);
	msg.hdr.len = htonl(0);
	msg.hdr.type = htonl(HFAPP_MSG_MODE_QRT);
	msg_send(&msg);
	display_status("QRT");
}


void on_speedup_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	struct hfapp_msg msg;

	msg.hdr.err = htonl(ERR_NOERR);
	msg.hdr.len = htonl(0);
	msg.hdr.type = htonl(HFAPP_MSG_MODE_SPEEDUP);
	msg_send(&msg);
	display_status("SPEEDUP");
}

void on_uppercase_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	struct hfapp_msg msg;

	msg.hdr.err = htonl(ERR_NOERR);
	msg.hdr.len = htonl(0);
	msg.hdr.type = htonl(HFAPP_MSG_CASE_UPPER);
	msg_send(&msg);
	display_status("UPPERCASE");
}


void on_lowercase_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	struct hfapp_msg msg;

	msg.hdr.err = htonl(ERR_NOERR);
	msg.hdr.len = htonl(0);
	msg.hdr.type = htonl(HFAPP_MSG_CASE_LOWER);
	msg_send(&msg);
	display_status("LOWERCASE");
}


void on_figurecase_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	struct hfapp_msg msg;

	msg.hdr.err = htonl(ERR_NOERR);
	msg.hdr.len = htonl(0);
	msg.hdr.type = htonl(HFAPP_MSG_CASE_FIGURE);
	msg_send(&msg);
	display_status("FIGURECASE");
}


void on_standby_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	struct hfapp_msg msg;

	msg.hdr.err = htonl(ERR_NOERR);
	msg.hdr.len = htonl(0);
	msg.hdr.type = htonl(HFAPP_MSG_START_STANDBY);
	msg_send(&msg);
	display_status("STANDBY FOR PACTOR - AMTOR - GTOR");
}

void on_standby_pactor_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	struct hfapp_msg msg;

	msg.hdr.err = htonl(ERR_NOERR);
	msg.hdr.len = htonl(0);
	msg.hdr.type = htonl(HFAPP_MSG_START_PACTOR_STANDBY);
	msg_send(&msg);
	display_status("STANDBY FOR PACTOR ");
}

void on_pactor_arq_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	struct hfapp_msg msg;

	msg.hdr.err = htonl(ERR_NOERR);
	msg.hdr.len = htonl(0);
	msg.hdr.type = htonl(HFAPP_MSG_START_PACTOR_ARQ);
	msg_send(&msg);
	display_status("PACTOR-ARQ");
}


void on_pactor_fec_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	struct hfapp_msg msg;

	msg.hdr.err = htonl(ERR_NOERR);
	msg.hdr.len = htonl(0);
	msg.hdr.type = htonl(HFAPP_MSG_START_PACTOR_FEQ);
	msg_send(&msg);
	display_status("PACTOR-FEC");
}


void on_gtor_arq1_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	struct hfapp_msg msg;

	msg.hdr.err = htonl(ERR_NOERR);
	msg.hdr.len = htonl(0);
	msg.hdr.type = htonl(HFAPP_MSG_START_GTOR_ARQ);
	msg_send(&msg);
	display_status("GTOR-ARQ");
}


void on_amtor_arq_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	struct hfapp_msg msg;

	msg.hdr.err = htonl(ERR_NOERR);
	msg.hdr.len = htonl(0);
	msg.hdr.type = htonl(HFAPP_MSG_START_AMTOR_ARQ);
	msg_send(&msg);
	display_status("AMTOR-ARQ");
}


void on_amtor_collective_fec_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	struct hfapp_msg msg;

	msg.hdr.err = htonl(ERR_NOERR);
	msg.hdr.len = htonl(0);
	msg.hdr.type = htonl(HFAPP_MSG_START_AMTOR_COLFEQ);
	msg_send(&msg);
	display_status("AMTOR-COLFEC");
}


void on_amtor_selective_fec_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	struct hfapp_msg msg;

	msg.hdr.err = htonl(ERR_NOERR);
	msg.hdr.len = htonl(0);
	msg.hdr.type = htonl(HFAPP_MSG_START_AMTOR_SELFEQ);
	msg_send(&msg);
	display_status("AMTOR-SELFEC");
}


void on_rtty_receive_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	struct hfapp_msg msg;

	msg.hdr.err = htonl(ERR_NOERR);
	msg.hdr.len = htonl(0);
	msg.hdr.type = htonl(HFAPP_MSG_START_RTTY_RX);
	msg_send(&msg);
	display_status("RTTY-RX");
}


void on_rtty_transmit_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	struct hfapp_msg msg;

	msg.hdr.err = htonl(ERR_NOERR);
	msg.hdr.len = htonl(0);
	msg.hdr.type = htonl(HFAPP_MSG_START_RTTY_TX);
	msg_send(&msg);
	display_status("RTTY-TX");
}

/* --- USER DATEN -------------------------------------------------- */ 
/* --- ("brag" heit angeben)--------------------------------------- */ 

void on_brag_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	  gtk_widget_show(wpersonal);
	  brag_set();
}

void on_brag_ok_button_clicked(GtkButton *button, gpointer user_data)
{
	brag_get();
	brag_set();
	gtk_widget_hide(wpersonal);
	brag_store();
}

void on_brag_cancel_button_clicked(GtkButton *button, gpointer user_data)
{
	brag_set();
	gtk_widget_hide(wpersonal);
}

void on_brag_delete_button_clicked(GtkButton *button, gpointer user_data)
{
	brag_delete();
	brag_set();
}

/* --- Fixtexte  ---------------------------------------------------- */ 
void on_Fix_button1_clicked(GtkButton *button, gpointer user_data)
{
	fixtext_send(1);
}

void on_Fix_button2_clicked(GtkButton *button, gpointer user_data)
{
	fixtext_send(2);
}

void on_Fix_button3_clicked(GtkButton *button, gpointer user_data)
{
	fixtext_send(3);
}

void on_Fix_button4_clicked(GtkButton *button, gpointer user_data)
{
	fixtext_send(4);
}

void on_Fix_button5_clicked(GtkButton *button, gpointer user_data)
{
	fixtext_send(5);
}

void on_Fix_button6_clicked(GtkButton *button, gpointer user_data)
{
	fixtext_send(6);
}

void on_Fix_button7_clicked(GtkButton *button, gpointer user_data)
{
	fixtext_send(7);
}

void on_Fix_button8_clicked(GtkButton *button, gpointer user_data)
{
	fixtext_send(8);
}

void on_Fix_button9_clicked(GtkButton *button, gpointer user_data)
{
	fixtext_send(9);
}

void on_Fix_button10_clicked(GtkButton *button, gpointer user_data)
{
	fixtext_send(10);
}

void on_Fix_button11_clicked(GtkButton *button, gpointer user_data)
{
	fixtext_send(11);
}

void on_Fix_button12_clicked(GtkButton *button, gpointer user_data)
{
	fixtext_send(12);
}

void on_monitor_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	  gtk_widget_show(wmonitor);
}

void on_about_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	gtk_widget_show(wabout);
}

/* ------------ HILFEDATEI -------------- */
void on_index1_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	gtk_widget_show(whilfe);
}

/* ------------	FIXTEXTE --------------  */
void on_Wfixtext_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	  gtk_widget_show(Wfixtext);
	  display_status("welcome to text macro studio.");
}

/* -- FIXTEXTE BEENDEN & SICHERN ------------------------------------ */
void on_button_Fixtext_OK_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_hide(Wfixtext);
	fixtext_store();
}

void on_button_Fixtext_Cancel_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_hide(Wfixtext);
}

void on_parabutton_clicked(GtkButton *button, gpointer user_data)
{
	  gtk_widget_show(wpar);
}

gboolean on_text_keypress_event(GtkWidget *widget, GdkEventKey *event, gpointer user_data)
{

//	char c = event->keyval;
//	printf("on_text_keypress_event: 0x%x %c  state %u\n",
//	event->keyval, (c >= ' ' && c <= 0x7f) ? c : '.', event->state);

	if (event->state & ~(GDK_SHIFT_MASK | GDK_LOCK_MASK))
		return FALSE;
	if (event->keyval == GDK_BackSpace) {
		edit_backspace();
		return TRUE;
	}
	if (event->keyval == GDK_Return) {
		edit_newline();
		return TRUE;
	}
	if (event->keyval >= 32 && event->keyval < 128) {
		edit_addchar(event->keyval);
		return TRUE;
	}
	return FALSE;
}

gboolean on_text_keyrelease_event(GtkWidget *widget, GdkEventKey *event, gpointer user_data)
{
//	char c = event->keyval;
//	printf("on_text_keyrelease_event: 0x%x %c  state %u\n", 
//	event->keyval, (c >= ' ' && c <= 0x7f) ? c : '.', event->state);
	return TRUE;
}

gboolean on_wmain_delete_event(GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
	gtk_main_quit();
	return FALSE;
}

gboolean on_wmain_destroy_event(GtkWidget *widget, GdkEvent *event, gpointer user_data)
{
	gtk_main_quit();
	return FALSE;
}

void on_aboutok_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_hide(wabout);
}

/* -------------- HILFEDATEI BEENDEN -------------------------------- */
void on_button17_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_hide(whilfe);
}

/* -------------- HINWEIS BEENDEN -------------- */
void on_button22_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_hide(whinweis);
}
/* -------------- HINWEIS BEENDEN --------------- */

/* ----------------- ZEIGEN DER WELTKARTE  ----------------------- */
void on_map1_activate(GtkMenuItem *menuitem, gpointer user_data)
{
	gtk_widget_show(wmap);
}

/* -------------- MAP BEENDEN ---------------- */
void on_enough_clicked (GtkButton *button, gpointer user_data)
{
	gtk_widget_hide(wmap);
}


